#include "config.h"

#include <sstream>
#include <stdexcept>

#include "QueryResultsMountPointStats.hh"

namespace diskCache
{
  QueryResultsMountPointStats::
  QueryResultsMountPointStats( format_type Format )
    : QueryResults( Format, TYPE_MOUNT_POINT_STATS )
  {
  }

  void QueryResultsMountPointStats::
  Finalize( )
  {
    switch( format( ) )
    {
    case FORMAT_TCL:
      for ( mount_point_info_type::const_iterator
	      cur_mnt_pt = m_stats.begin( ),
	      last_mnt_pt = m_stats.end( );
	    cur_mnt_pt != last_mnt_pt;
	    ++cur_mnt_pt )
      {
	std::ostringstream	stats;
	INT_4U	file_sum = 0;
	for ( dir_info_type::const_iterator
		cur_dir_info = cur_mnt_pt->second.begin( ),
		last_dir_info = cur_mnt_pt->second.end( );
	      cur_dir_info != last_dir_info;
	      ++cur_dir_info )
	{
	  file_sum += cur_dir_info->second;
	}
	tcl_list_begin( stats );
	stats << cur_mnt_pt->first
	      << " " << cur_mnt_pt->second.size( )
	      << " " << file_sum;
	tcl_list_end( stats );

	if ( m_string_result.length( ) > 0 )
	{
	  m_string_result += " ";
	}
	m_string_result += stats.str( );
      }
      break;
    default:
      // Do nothing
      break;
    }
  }
} // namespace - diskCache
